fivecards = {};
hiddencard={};
clicked=False;
rules={1->"club2.gif",2->"diamond2.gif",3->"heart2.gif",4->"spade2.gif"};
rules2={1->"A",11->"J",12->"Q",13->"K"};


UnsortedUnion[x_] := Module[{f}, f[y_] := (f[y] = Sequence[]; y); f /@ x];

showCards[a_]:=
  (a /.{
  {t_,4} :> StringJoin[ToString[t/.rules2], FromCharacterCode[9824]],
  {t_,3} :> StringJoin[ToString[t/.rules2], FromCharacterCode[9829]],
  {t_,2} :> StringJoin[ToString[t/.rules2], FromCharacterCode[9830]],
  {t_,1} :> StringJoin[ToString[t/.rules2], FromCharacterCode[9827]]
  })//ToString;

updateCards[]:=
(fivecards=UnsortedUnion[fivecards];
If[Length[fivecards]>=5,
    fivecards=Take[fivecards,-5];
    SetPropertyValue[{"pickCardPage", "allowNext"}, True];
    encodeCard[];
   ];
SetPropertyValue[{"fivecards","text"},ToString[showCards/@fivecards]];
);


encodeCard[]:=Module[{card1,a,b,s,cards,temp,k},
    (* find at least two cards with the same suit *)
    temp=Split[Sort[fivecards, #1[[2]] > #2[[2]] &], #1[[2]] == #2[[2]] &];
    {{a,s},{b,s}}=Select[temp, Length[#] >= 2 &][[1,{1,2}]] // Sort;
    
    (* modulo 13 arithmetic *)
    k=b-a;
    (* always hide the "smaller" card *)
    If[k>6,(hiddencard={a,s};card1={b,s};k=13-k),(hiddencard={b,s};card1={a,s})];
    
    (* encode 1 to 6 by the rest three cards by their permutatoins *)
    cards=Select[fivecards, # != hiddencard && #!=card1&]// Sort;
    cards=Permutations[cards][[k]];
        
    SetPropertyValue[{"c1","text"}, ToString[card1[[1]]/.rules2]];
    SetPropertyValue[{"c1","icon"}, Widget["Icon", {"path" -> card1[[2]]/.rules}]];
    
    SetPropertyValue[{"c2","text"}, ToString[cards[[1,1]]/.rules2]];
    SetPropertyValue[{"c2","icon"}, Widget["Icon", {"path" -> cards[[1,2]]/.rules}]];
    
    SetPropertyValue[{"c3","text"}, ToString[cards[[2,1]]/.rules2]];
    SetPropertyValue[{"c3","icon"}, Widget["Icon", {"path" -> cards[[2,2]]/.rules}]];

    SetPropertyValue[{"c4","text"}, ToString[cards[[3,1]]/.rules2]];
    SetPropertyValue[{"c4","icon"}, Widget["Icon", {"path" -> cards[[3,2]]/.rules}]];
    
    clicked=False;
    SetPropertyValue[{"c5","text"}, ""];
    SetPropertyValue[{"c5","icon"}, Widget["Icon", {"path" -> "blank.gif"}]];
               
    ];
    
BindEvent[{"c5","action"},Script[clicked = clicked /. {True -> False, False -> True};
    If[clicked,
        SetPropertyValue[{"c5","text"}, ToString[hiddencard[[1]]/.rules2]];
        SetPropertyValue[{"c5","icon"}, Widget["Icon", {"path" -> hiddencard[[2]]/.rules}]],
        
        SetPropertyValue[{"c5","text"}, ""];
        SetPropertyValue[{"c5","icon"}, Widget["Icon", {"path" -> "blank.gif"}]]
                                     ];]]